require 'sketchup.rb'

module TT_Test
	
	# Add some menu items to access this
	unless file_loaded?('test.rb')
		plugins_menu = UI.menu('Plugins')
		plugins_menu.add_item('Test')	{ self.test }
	end
	
	# Constants
	unless file_loaded?('test.rb')
	POINT_OPEN_SQUARE		= 1
	POINT_FILLED_SQUARE		= 2
	POINT_CROSS				= 3
	POINT_X					= 4
	POINT_STAR				= 5
	POINT_OPEN_TRIANGLE		= 6
	POINT_FILLED_TRIANGLE	= 7
	end
	
	# Shorthand to activate tools
	def self.test
		Sketchup.active_model.select_tool(Test.new)
	end
	
	################################################################################################
	class Test

		def initialize
			#
		end
		
		def activate
			#
		end
		
		def deactivate(view)
			view.refresh
		end
		
		def onMouseMove(flags, x, y, view)
			view.refresh
		end
		
		def draw(view)		
			view.line_width = 1
			view.drawing_color = 'Blue'
			view.draw2d(GL_LINES, [ [500.5,200.5,0], [700.5,300.5,0] ])
			
			# Edges with odd number thickness need to have co-ordinates that hits in the middle of 
			# the pixel - hence the extra .5 value.
			square_edge = [ [200.5,400.5,0], [200.5,500.5,0], [400.5,500.5,0], [400.5,400.5,0] ]
			square_fill = [ [200.0,400.0,0], [200.0,500.0,0], [400.0,500.0,0], [400.0,400.0,0] ]
			
			square_3d = [ [0,0,0], [100,0,0], [100,0,100], [0,0,100] ]
			square_3d_2 = [ [0,200,0], [100,200,0], [100,200,100], [0,200,100] ]
			
			view.drawing_color = 'Yellow'
			view.draw2d(GL_QUADS, square_fill)
			
			# (!) Fails to use drawing colour
			view.draw(GL_QUADS, square_3d)
			view.draw(GL_POLYGON, square_3d_2)
			
			view.line_width = 5
			view.drawing_color = 'Blue'
			view.draw2d(GL_LINE_LOOP, square_edge)
			
			view.draw2d(GL_LINES, [ [800.5,200,0], [800.5,300,0] ])
			
			# (!) Fails to use drawing colour
			view.draw_text([200,600,0], 'Hello world')
		end

	end
	
end


#-----------------------------------------------------------------------------
file_loaded('test.rb')
#-----------------------------------------------------------------------------